package	jp.co.sds_corp.streaming;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JToolTip;

import jp.co.sds_corp.nanchart.graph.DefaultStorage;
import jp.co.sds_corp.nanchart.graph.Graph2D;
import jp.co.sds_corp.nanchart.graph.StairGraph;
import jp.co.sds_corp.nanchart.graph.XScale;
import jp.co.sds_corp.nanchart.graph.YScale;
import jp.co.sds_corp.util.common.CmnDate;

public class GraphTip extends JToolTip
{
	protected int				bs_flg;
	protected int				point;
	protected String			pair;
	protected BufferedImage		img = null;
	protected Vector			vecHist = new Vector();
	protected DecimalFormat		df;

	public GraphTip( String pair, int bs_flg, int point ) {
		super();
		this.pair = pair;
		this.bs_flg = bs_flg;
		this.point = point;

		initHist( pair, bs_flg );

		String pattern = "0.0000000000".substring( 0, point+2 );
		df = new DecimalFormat( pattern );
		setBorder( BorderFactory.createEtchedBorder() );
	}

	private void initHist( String pair, int bs_flg ) {
/*
		try {
			URL url = new URL( CmnEnv.SERVLET_HOME
								+ "/business.servlet.indicate.RateData" );
			URLConnection ucon = url.openConnection();
			ucon.setDoOutput( true );
			ucon.setDoInput( true );
			ucon.setUseCaches( false );
			ObjectOutputStream oos =
				new ObjectOutputStream( ucon.getOutputStream() );
			Object[] param = new Object[5];
			param[0] = pair.ccy_code;
			param[1] = pair.base_ccy_code;
			param[2] = new Integer( bs_flg );
			param[3] = new Integer( CmnDate.MINUTE );
			param[4] = new Integer( -30 );
			oos.writeObject( param );
			oos.flush();
			oos.close();

			ObjectInputStream ois =
				new ObjectInputStream( ucon.getInputStream() );
			TreeMap mapHist = (TreeMap )ois.readObject() ;
			Iterator itr = mapHist.keySet().iterator();
			while ( itr.hasNext()) {
				String key = (String )itr.next();
				RateHist hist = (RateHist )mapHist.get( key );
				vecHist.add( hist );
			}
			ois.close();

			RateHist hist = new RateHist();
			hist.dt = new CmnDate();
			if ( bs_flg == CmnStaticCode.SIDE_LEFT ) {
				if( sp.getTerm() == null ) {
					hist.rate = rateEx.getOddFwdRate( sp.getDate() ).l_rate;
				} else {
					hist.rate = rateEx.getFwdRate( sp.getTerm() ).l_rate;
				}
			} else {
				if( sp.getTerm() == null ) {
					hist.rate = rateEx.getOddFwdRate( sp.getDate() ).r_rate;
				} else {
					hist.rate = rateEx.getFwdRate( sp.getTerm() ).r_rate;
				}
			}
			vecHist.add( hist );
		} catch ( Exception e ) {
			e.printStackTrace();
		}
*/
	}
/*
	public void setComponent( JComponent c ) {
		super.setComponent( c );
		c.addMouseListener( new MouseAdapter() {
			public void mouseEntered( MouseEvent e ) {
				setBounds( e.getX(), e.getY(), 350, 150 );
				setVisible(true);
			}
			public void mouseExited( MouseEvent e ) {
				setVisible(false);
			}
		} );
	}
*/
	public String getTipText() {
		return " ";
	}

	public Dimension getPreferredSize() {
		return new Dimension( 350, 150 );
	}

	protected void drawGraph( Graphics2D g ) {
		CmnDate to = new CmnDate();
		CmnDate fr = (CmnDate )to.clone();
		fr.add( CmnDate.MINUTE, -30 );

		RateHist cur, pre = null;
		double	dMax = 0, dMin = 999999999999999.0;
		int		nPos;
		for ( nPos = 0; nPos < vecHist.size(); nPos++ ) {
			cur = (RateHist )vecHist.get( nPos );
			if ( cur.dt.after( fr )) {
				break;
			}
		}
		for ( int i = 0; i < nPos-1; i++ ) {
			if ( vecHist.size() > 1 ) {
				cur = (RateHist )vecHist.remove( 0 );
			}
		}
		for ( int i = vecHist.size() - 1; i >= 0; i-- ) {
			cur = (RateHist )vecHist.get( i );
			double rate = cur.rate.doubleValue();
			if ( dMax < rate ) {
				dMax = rate;
			}
			if ( dMin > rate ) {
				dMin = rate;
			}
		}
		double	dDiv = Math.pow( 10, point - 1 );
		dMin = ( Math.floor( dMin*dDiv )) / dDiv ;
		dMax = ( Math.floor( dMax*dDiv ) + 1.0 ) / dDiv ;

		Graph2D grf = new Graph2D( fr, to, new Double( dMin ), new Double( dMax ));
		StairGraph dat = new StairGraph( fr, to,
						new BigDecimal( dMin ), new BigDecimal( dMax ));
		dat.setStroke(
			new BasicStroke( 1, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_BEVEL ));
		DefaultStorage dt = (DefaultStorage)dat.getStorage();
		grf.addSeries( dat );
		dat.setLineColor( Color.black );

		Font font = new Font( "Dialog", Font.PLAIN, 10 );
		XScale	xs = (XScale )grf.getXScale();
		xs.add( fr, fr.format( "HH:mm" ));
		CmnDate tmp = (CmnDate )fr.clone();
		tmp.set( CmnDate.SECOND, 0 );
		for ( ;; ) {
			tmp.add( CmnDate.MINUTE, 1 );
			if ( tmp.after( to ) ) {
				break;
			}
			if (( tmp.get( CmnDate.MINUTE ) % 10 ) == 0 ) {
				double dFr = fr.getTime().getTime();
				double dTo = to.getTime().getTime();
				double dCr = tmp.getTime().getTime();
				if (( ( dCr - dFr ) < ( 3 * 60 * 1000 )) ||
					( ( dTo - dCr ) < ( 3 * 60 * 1000 )))
				{
					xs.add( tmp.clone(), "" );
				} else {
					xs.add( tmp.clone(), tmp.format( "HH:mm" ));
				}
			}
		}
		xs.add( to, to.format( "HH:mm" ));
		xs.setStroke( new BasicStroke( 1,
				BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				0, new float[]{2,5}, 0 ));
		xs.setScaleLine( true );
		xs.setFont( font );

		YScale	ys = (YScale )grf.getYScale(); //new YScale( dMin, dMax );
		ys.setFont( font );
		ys.add( dMin, df.format( dMin ));
		ys.add( dMax, df.format( dMax ));
		for ( int i = (int )(dMin*dDiv); i < (int )(dMax*dDiv); i++ ) {
			ys.add( (double)i / dDiv, df.format( (double)i / dDiv ));
		}
		ys.setStroke( new BasicStroke( 1,
				BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
				0, new float[]{2,5}, 0 ));
		ys.setScaleLine( true );

		cur = null;
		for ( int i = 0; i < vecHist.size(); i++ ) {
			cur = (RateHist )vecHist.get( i );
			dt.add( new CmnDate( cur.dt.getTime()), cur.rate );
			pre = cur;
		}
		if ( cur != null ) {
			dt.add( new CmnDate(), cur.rate );
		}
		Rectangle rect = new Rectangle( 50, 10, 250, 100 );
		grf.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
								RenderingHints.VALUE_ANTIALIAS_ON);
		grf.drawGraph( g, rect );
//		img = grf.getImage( 250, 100, rect, BufferedImage.TYPE_INT_RGB );
//		g.drawImage( img, new AffineTransform(1f,0f,0f,1f,0,0), null);
	}

	public void paint( Graphics g ) {
		super.paint( g );
		drawGraph( (Graphics2D )g );
	}

	public void addRate( BigDecimal rate ) {
		if ( rate.equals( BigDecimal.valueOf( 0 ))) {
			return;
		}
		RateHist hist = new RateHist();
		hist.dt = new CmnDate();
		hist.rate = rate;
		vecHist.add( hist );
		repaint();
	}
}
