package	jp.co.sds_corp.streaming;

import java.awt.Color;
import java.awt.Rectangle;
import java.math.BigDecimal;

import javax.swing.JToolTip;
import javax.swing.SwingConstants;

import jp.co.sds_corp.util.common.CmnDate;
import jp.co.sds_corp.util.window.ScalableFontButton;

public class RateButton extends ScalableFontButton
{
	public static final int	INT = 0;
	public static final int	BID = 1;
	public static final int	ASK = 2;
	public static final int	TOP = 9;
	static Color	COLOR_UP = Color.red;
	static Color	COLOR_DOWN = Color.blue;
	static Color	COLOR_DEFAULT = Color.black;
	int				nSetColor = 0;
	BackColorThread	thr;
	int				nType;
	GraphTip		TIP;
	String			ccy1, ccy2, term;

	public RateButton( String text, int nType, String pair, int nPrec ) {
		this( text, nType );
		setPair( pair, nPrec );
	}

	public RateButton( String text, int nType ) {
		super( text );
		setVerticalAlignment( SwingConstants.BOTTOM );
		setRequestFocusEnabled( false );
		setFocusPainted(false);

		thr = new BackColorThread( this );
		thr.start();
		this.nType = nType;
	}

	public void setPair( String pair, int nPrec ) {
		ccy1 = pair.substring( 0, 3 );
		ccy2 = pair.substring( 3, 6 );
		term = pair.substring( 6, 8 );
		if ( nType == BID || nType == ASK ) {
			TIP = new GraphTip( pair, 0, nPrec );
			TIP.setComponent( this );
			setToolTipText( "" );
		}
	}

	public JToolTip createToolTip() {
		return TIP;
	}

	boolean		bInit = false;
	String		srate;
	BigDecimal	rate;
	public void setRate( BigDecimal oldRate, BigDecimal newRate ) {
		if ( nType == BID || nType == ASK ) {
			TIP.addRate( newRate );
		}
		String text = newRate.toString();
		if ( text.length() < 2 ) {
			return;
		}
		if ( nType == INT ) {
			String stmp;
			if ( term.equals( "SP" )) {
				stmp = text.substring( 0, text.length()-2 );
			} else {
				stmp = text.substring( 0, text.length()-4 );
			}
			if ( stmp.charAt( stmp.length()-1 ) == '.' ) {
				stmp = stmp.substring( 0, stmp.length()-1 );
			}
			if ( srate == null || !srate.equals( stmp )) {
				setText( stmp );
				srate = stmp;
			}
		} else {
			String stmp;
			if ( term.equals( "SP" )) {
				stmp = text.substring( text.length()-2 );
			} else {
				stmp = text.substring( text.length()-4, text.length()-2 );
			}
			if ( rate == null || !newRate.equals( rate )) {
				setText( stmp );
				if ( oldRate != null ) {
					if ( oldRate.compareTo( newRate ) < 0 ) {
						setForeground( COLOR_UP );
					} else if ( oldRate.compareTo( newRate ) > 0 ) {
						setForeground( COLOR_DOWN );
					}
/*
					nSetColor++;
					thr = new BackColorThread( this );
					thr.start();
*/
					thr.updated();
				}
				srate = stmp;
			}
		}
		rate = newRate;
		if ( !bInit ) {
			Rectangle rect = getBounds();
			reshape( (int )rect.getX(), (int )rect.getY(),
						(int )rect.getWidth(), (int )rect.getHeight() );
			bInit = true;
		}
	}

	synchronized public int decColorCount() {
		int nOrg = nSetColor;
		if ( nSetColor > 0 ) {
			nSetColor--;
		}
		return nOrg;
	}

	class BackColorThread extends Thread
	{
		RateButton	btn;
		CmnDate		upd = null;

		BackColorThread( RateButton btn ) {
			this.btn = btn;
		}

		public void updated() {
			setUpdate( new CmnDate() );
		}

		synchronized public void setUpdate( CmnDate dt ) {
			upd = dt;
		}

		public void run() {
			for ( ;; ) {
				if ( upd != null ) {
					CmnDate now = new CmnDate();
					long lDiff = now.getTimeInMillis() - upd.getTimeInMillis();
					if ( lDiff > 1000 ) {
						btn.setForeground( COLOR_DEFAULT );
						setUpdate( null );
					}
				}
				yield();
				try {
					sleep( 300 );
				} catch ( Exception e ) {
				}
			}
/*
			yield();
			try {
				sleep( 1000 );
			} catch ( Exception e ) {
			}
			if ( decColorCount() > 0 ) {
				btn.setForeground( COLOR_DEFAULT );
			}
*/
		}
	}
}

